enum
{
   E_bomber,
   E_crate,
   E_composed,
   E_split,
   E_tiny,
   E_powerup,
   E_stacked,
};

#define INFINITE_MASS  1000001
struct Vehicle
{
   float radius;
   float speed_min, speed_max;
   float turn_min , turn_max ;
   float turn_acc , turn_dec ;
   float reload_delay        ;
   float mass;
};

enum ObjType
{
   T_player,
   T_object,
   T_base,
   T_bullet,
   T_effect,
};

enum EffectType
{
   E_particle,
   E_bomb,
   E_soul,
   E_soul2,
};

struct Base
{
   int tile_x, tile_y;
};

struct Model;

struct Object
{
   ObjType type;
   int subtype;
   int subsubtype; // ludicrousness reigns!
   vec loc, velocity;
   vec angles, turn_rate;
   bool destroyed;
   float speed;
   int health;
   Object *creator;
   Vehicle *v;
   Base *base;
   Model *model;

   float lifetime, reload_time;

   float ai_timer, ai_data;
   int   ai_state, ai_data2;

   ::Object(vec ploc, ObjType type_):
        loc(ploc), type(type_),
        creator(NULL),
        subtype(0),
        subsubtype(0),
        model(NULL),
        turn_rate(),angles(),
        destroyed(false)
   {
      ai_state    = 0;
      speed       = 0;
      health      = 100;
      reload_time = 0;
   }

   mat orientation();
   float radius();
   vec color();

   void draw();
   void tick(float dt);

   void moveTo(const vec &goal);

   void kill() { destroyed = true; }
   void die();
};

extern bool collide(Object *a, Object *b, const vec &a_to_b_normal);

extern Object *player, *p2, *mbase;
extern void explosion(const vec &where, int num, float speed, float life, float z_bias, int subtype);
extern void sparks(const vec &where, int num, vec speed, float life, float range, int subtype);
