#include "s.h"

float prand() { return rand() / 32768.0f; }
float frand() { return prand()*2-1; }

vec rvec(float x, float y, float z) {
   return vec(x*frand(),y*frand(),z*frand());
}

extern float smoothSpeed(
      float current,
      float goal,
      float max_accel,
      float max_decel,
      float dt)
{
   if (current == goal) return goal;

   bool flip_sign = false;
   if (goal < 0) {
      goal = -goal;
      current = -current;
      flip_sign = true;
   }

   // if goal < current, decelerate
   if (goal < current) {
      current -= max_decel * dt;
      if (current < goal) current = goal;
   } else {
      if (current < 0) {
         // we're crossing 0, which means we can
         // decelerate to 0
         assert(max_decel >= max_accel);
         current += max_decel*dt;
      } else {
         current += max_accel*dt;
      }
      if (current > goal) current = goal;
   }

   return flip_sign ? -current : current;
}

float angmod(float a)
{
   return fmod(a,2*PI) + (a < 0 ? 2*PI : 0);
}
