#include "s.h"

mat rotationMatrix(float ang, const vec &axis)
{
   vec r = axis;
   r.normalize();

   float  s = sin(ang),  c = cos(ang);
   mat m;
   // formula from OpenGL blue book
   m.v[0][0] = (1-c) * r.x * r.x  +   c        ;
   m.v[0][1] = (1-c) * r.x * r.y  -   s * r.z  ;
   m.v[0][2] = (1-c) * r.x * r.z  +   s * r.y  ;

   m.v[1][0] = (1-c) * r.y * r.x  +   s * r.z  ;
   m.v[1][1] = (1-c) * r.y * r.y  +   c        ;
   m.v[1][2] = (1-c) * r.y * r.z  -   s * r.x  ;

   m.v[2][0] = (1-c) * r.z * r.x  -   s * r.y  ;
   m.v[2][1] = (1-c) * r.z * r.y  +   s * r.x  ;
   m.v[2][2] = (1-c) * r.z * r.z  +   c        ;

   return m;
}

void glmat(float out[16], const mat &ori, const vec &loc)
{
   for (int j=0; j < 3; ++j) {
      for (int i=0; i < 3; ++i)
         // gl matrix is column-major instead of row-major
         out[j*4+i] = ori.v[i][j];
      out[j*4+3] = 0;
   }
   out[12] = loc.x;
   out[13] = loc.y;
   out[14] = loc.z;
   out[15] = 1;
}
